#!/usr/bin/perl -w
use strict;
use FindBin qw($Bin);
#explanation:this program is edited to 
#edit by HeWeiMing;   Thu Dec  9 16:59:01 CST 2010
#Version 1.0    hewm@genomics.org.cn 

sub  usage
{
print STDERR <<USAGE;
usage: perl $0 individual.txt add_ref.list  OutDir
USAGE
exit (1) ;
}
#usage();
my $OutDir=`pwd`; chomp $OutDir ; 
my $individual="$OutDir/individual.txt";
my $add_ref="$OutDir/add_ref.list" ;
    $individual=(@ARGV) ? shift : $individual ;
    $add_ref=(@ARGV) ? shift :$add_ref ;
    $OutDir=(@ARGV) ? shift :$OutDir;

usage()  if ( ! -s $individual )  ;
usage()  if ( ! -s $add_ref    )  ;
usage()  if ( ! -e $OutDir     )  ;

    my $bin=$Bin ;
    my $oshbin="perl  $bin/osh.pl ";
    my $No_addref="perl  $bin/No_addref.pl" ;

    my $shelldir="$OutDir/shell";
    my $Outdir="$OutDir/Out";
    system("mkdir -p $shelldir  $Outdir ");
    my $badlog="$OutDir/bad.log";
    my $comlist="$OutDir/com.list";
    system("ls  $Outdir/*.com >$comlist 2>$badlog ") ;
    if (-z $badlog )
    {
        open (CH ,"<$comlist" ) or die "$!";
        while($_=<CH>)
        {
            chomp ;
           if (! -s $_ ) 
           {
                print "$_ wrong\n";
                exit (1);
           }
        }
        close CH ;
         system ("$oshbin   01 01 NJ  perl   $bin/whole_pdistance.pl  $Outdir   $OutDir/individual.datamatrix  ^ $bin/fneighbor -datafile  $OutDir/individual.datamatrix   -outfile   $OutDir/tree.out1   -matrixtype s   -treetype   n    -outtreefile    $OutDir/tree.out2  ");
         system (" sh  NJ.sh") ;
        unlink $comlist ; 
        unlink $badlog ;
        exit (1);
    }
    unlink $badlog ;  unlink $comlist ;

    chdir  $shelldir ;
    open (FL , "<$add_ref") || die "$!" ;
    while (<FL>)
    {
      chomp ;
      my @inf=split /\//;
      my $id=(split(/\./,$inf[-1]))[0];
      my $snpNumber=`wc  -l $_ |  cut -f 1 -d " " ` ; chomp $snpNumber ;
      system ("$oshbin  01 01 I$id  $No_addref  $_ \\\> $Outdir/$id.genotype ^ perl $bin/Com_for_tree_V3.pl   $Outdir/$id.genotype $snpNumber    $individual  AA  $id  $Outdir/$id.com  ^ rm  $Outdir/$id.genotype ");
      system("qsub  -cwd -l vf=0.688G  -S /bin/sh I$id.sh ") ;
    }
    close FL ;
    print "after the shell run out,pls perl $0 again !\n";

#####################swimming in the sky and flying in the sea ###########################
