#!/usr/bin/perl

use File::Basename;
use FindBin qw($Bin);
#my $dir=`pwd`;
my $dir=shift;
my $cut_off=shift;
my $distance=shift;
$cut_off ||=0.95;
$distance ||=50000;

my $file_name=basename $dir;
mkdir  $file_name unless (-d $file_name);

chomp $dir;

my @aa=split(/\_/,$file_name);
my $out_file_mean="$file_name/$aa[0]\_xpclr_score_mean";
my $out_file="$file_name/$aa[0]\_xpclr_score";

`rm $out_file_mean` if (-f $out_file_mean);

open OUT,">$out_file" or die "$!";
for my $file(<$dir/*.clrgs.txt>){
	system "perl $Bin/mean_10k.pl  $file >> $out_file_mean";
        my $file_name2=basename $file;
        my $chr=(split(/\./,$file_name2))[0];
        open IN,$file or "$!";
        while(<IN>){
                chomp;
                next if(/inf/);
                my @f=split;
                $f[3]=int $f[3];
                print OUT "$chr\t$f[3]\t$f[5]\n";
        }
        close IN;
}
close OUT;




#=pod

################       mean  select and select region  #################

my $r_file="$out_file_mean.R";
open R,">$r_file" or die "$!";
my $aa=100-100*$cut_off;
print R "read.table(\"$out_file_mean\")->ch
ch\$V3->xx
quantile(xx,probs=$cut_off)->xa
xa
write(xa,file=\"$file_name\_top_$aa.txt\",append =TRUE)
q()\n";
close R;
`R < $r_file --vanilla`;

open IN,"$file_name\_top_$aa.txt" or die  "$!";
my $top_cut;
while(<IN>){
	chomp;
	$top_cut=$_;
}
close IN;


open  IA,$out_file_mean or die  "$!";
my $select="$out_file_mean.select";
open  OA,">$select" or die "$!";
my %region;
while(<IA>){
	chomp;
	my @f=split;
	if($f[2]>$top_cut){
		push @{$region{$f[0]}},$f[1];
		print OA "$_\n";
	}
}
close OA;
close IA;

my $select_region="$select.region";
open RE,">$select_region" or die "$!";
foreach my $chr(sort keys %region){
my @aa=@{$region{$chr}};
@aa=sort {$a<=>$b}@aa;
my $st=$aa[0];
my $en=$aa[0]+10000;

for(my $i=1;$i<=$#aa;$i++){
	if(($en+$distance)>=$aa[$i]){
		$en=$aa[$i]+10000;
	}else{
		my $len=$en-$st;
		print RE "$chr\t$st\t$en\t$len\n";
		$st=$aa[$i];
		$en=$aa[$i]+10000;
	}
}
my $len=$en-$st;
print RE "$chr\t$st\t$en\t$len\n";

}
close RE;

##############    point  select   #################
my $r_file="$out_file.R";

open R,">$r_file" or die "$!";
my $aa=100-100*$cut_off;
print R "read.table(\"$out_file\")->ch
ch\$V3->xx
quantile(xx,probs=$cut_off)->xa
xa
write(xa,file=\"$file_name\_top_$aa.txt\",append =TRUE)
q()\n";
close R;
`R < $r_file --vanilla`;

open IN,"$file_name\_top_$aa.txt" or die  "$!";
my $top_cut;
while(<IN>){
        chomp;
        $top_cut=$_;
}
close IN;


open  IA,$out_file or die  "$!";
my $select="$out_file.select";
open  OA,">$select" or die "$!";
while(<IA>){
        chomp;
        my @f=split;
        print OA "$_\n" if($f[2]>$top_cut);
}
close OA;
close IA;







