use warnings;
use strict;
use Bio::PopGen::IO;
use Bio::PopGen::Statistics;
use Bio::PopGen::PopStats;

die "Input file: ms simulation result; individual numbers (n1-n2 format)!\n" unless @ARGV==4;
open MS,"$ARGV[0]" or die "$!";
my @n1=split(/-/,$ARGV[1]);
my @n2=split(/-/,$ARGV[2]);

$/='//';
<MS>;
my $m=0;
while(<MS>)
{
    $m++;
    chomp;
    my @inf=split(/\n/,);
    shift(@inf);shift(@inf);
    my $info=shift(@inf);
    my @tmp=split(/\s+/,$info);shift(@tmp);my $markers=join("\t",@tmp);
    $info=~s/positions/SAMPLE/;$info=~s/:\s/,/;$info=~s/\s/,/g;chop($info);
    my $sample1="$info\n";
    my $sample2="$info\n";
    for(my $i=0;$i<@inf;$i++)
    {
        my $geno="ID$i,";
        for(my $j=0;$j<length($inf[$i]);$j+=2)
        {
            my $indigeno=substr($inf[$i],$j,2);
            my $g1=substr($indigeno,0,1);
            my $g2=substr($indigeno,1,1);
            $geno.="$g1 $g2,";
        }
        chop($geno);#$geno=~s/0/A/g;$geno=~s/1/T/g;
        if($i>=$n1[0]-1 && $i<=$n1[1]-1)
        {
            $sample1.="$geno\n";
        }
        if($i>=$n2[0]-1 && $i<=$n2[1]-1)
        {
            $sample2.="$geno\n";
        }
    }
    open O1,">tmp1.csv" or die $!;
    open O2,">tmp2.csv" or die $!;
    open O3,">info.txt" or die $!;
    print O1 "$sample1";
    print O2 "$sample2";
    print O3 "Loci$m\t0\t$markers";
    close O1;
    close O2;
    close O3;

    `perl count_pop_statistics.pl >>simu$ARGV[3].result`;
    #my $stats1= Bio::PopGen::Statistics->new();
    #my $stats2=Bio::PopGen::PopStats->new();
    #my $ioc = Bio::PopGen::IO->new(-format => 'csv',-file => 'tmp1.csv');
    #my $iow = Bio::PopGen::IO->new(-format => 'csv',-file => 'tmp2.csv');
    #my $pop1=Bio::PopGen::Population->new();
    #my $pop2=Bio::PopGen::Population->new();
    #if( $pop1 = $ioc->next_population ) {
    #    my $pi = $stats1->pi($pop1);
    #    my $theta = $stats1->theta($pop1);
    #    my $tajimad=$stats1->tajima_D($pop1);
    #    print "\t$pi $theta $tajimad\n";
    #}
    #if( $pop2 = $iow->next_population) {
    #    my $pi = $stats1->pi($pop2);
    #    my $theta = $stats1->theta($pop2);
    #    my $tajimad=$stats1->tajima_D($pop2);
    #    print "\t$pi $theta $tajimad";
    #}
    #my @populations;
    #push(@populations,$pop1);
    #push(@populations,$pop2);
    #my @markernames=@tmp;
    #my $fst = $stats2->Fst(\@populations,\@markernames);
    #print "\t$fst\n";
}

close MS;

#####################################
