use warnings;
use strict;
use Bio::PopGen::IO;
use Bio::PopGen::Statistics;
use Bio::PopGen::PopStats;

    my $stats1= Bio::PopGen::Statistics->new();
    my $stats2=Bio::PopGen::PopStats->new();
    my $ioc = Bio::PopGen::IO->new(-format => 'csv',-file => 'tmp1.csv');
    my $iow = Bio::PopGen::IO->new(-format => 'csv',-file => 'tmp2.csv');
    my $pop1=Bio::PopGen::Population->new();
    my $pop2=Bio::PopGen::Population->new();
    if( $pop1 = $ioc->next_population ) {
        my $pi = $stats1->pi($pop1);
        my $theta = $stats1->theta($pop1);
        my $tajimad=$stats1->tajima_D($pop1);
        print "\t$pi $theta $tajimad\n";
    }
    if( $pop2 = $iow->next_population) {
        my $pi = $stats1->pi($pop2);
        my $theta = $stats1->theta($pop2);
        my $tajimad=$stats1->tajima_D($pop2);
        print "\t$pi $theta $tajimad";
    }
    my @populations;
    push(@populations,$pop1);
    push(@populations,$pop2);
    #my @markernames=@tmp;
    my $fst = $stats2->Fst(\@populations);
    print "\t$fst\n";

close MS;

#####################################
