import os

import numpy

import demographic_models
import dadi
from numpy import array

fsc = dadi.Spectrum.from_file('spectrum.fs')
#fswj = fswj.project([20,40])

data=fsc.fold()
#data.mask[1] = True
#data.mask[1]= data.mask[2] = True
#data.mask[1,:] = data.mask[:,1] = data.mask[-2,:] = data.mask[:,-2] = True
#data.mask[2,:] = data.mask[:,2] = data.mask[-3,:] = data.mask[:,-3] = True
# Mask out anything seen 4 or fewer times.
#data.mask[:5,0] = data.mask[0,:5] = True
ns = data.sample_sizes

pts_l = [40,50,60]
#dadi.Integration.set_timescale_factor(pts_l[-1], factor=10)

func = dadi.Demographics2D.IM

upper_bound = [100,100,100,100,100,100]
lower_bound = [0,0,0,0,0,0]
## (nuB, nuF, Tb, Tf)
params = array([0.001,0.1,0.5,0.1,0.001,0.001])

func_ex = dadi.Numerics.make_extrap_func(func)
model = func_ex(params, ns, pts_l)
ll_model = dadi.Inference.ll_multinom(model, data)
print 'Model log-likelihood:', ll_model

p0 = dadi.Misc.perturb_params(params, fold=1, upper_bound=upper_bound)
popt = dadi.Inference.optimize_log(p0, data, func_ex, pts_l,
                                   lower_bound=lower_bound,
                                   upper_bound=upper_bound,
                                   verbose=len(params))

print 'Optimized parameters', repr(popt)
model = func_ex(popt, ns, pts_l)
ll_opt = dadi.Inference.ll_multinom(model, data)
theta = dadi.Inference.optimal_sfs_scaling(model, data)
print 'Optimized theta', theta
import pylab
# Plot the comparison
fig = pylab.figure(9)
fig.clear()
dadi.Plotting.plot_1d_comp_multinom(model, data)
pylab.show()

#
# Check that our ms simulations actually match the model we're using.
#

#iter = 1e4
#core = demographic_models.bottleneck_in_two_mscore(popt)
#core = demographic_models.Caicedo_mscore(popt)
#ms_comm = dadi.Misc.ms_command(1, ns, core, iter)
#os.system('%s > temp.msout' % ms_comm)
#fs_ms = dadi.Spectrum.from_ms_file('temp.msout', average=False)

#import pylab
# Plot the 2d comparison
#fig = pylab.figure(10)
#fig.clear()
#dadi.Plotting.plot_2d_comp_multinom(iter*model.fold(), fs_ms.fold(), vmin=1,pop_ids=['Wild', 'Indica'])
#pylab.show()
